;*********************************************************************
;                       Mp3 PuBliC
;                      MP3 CD Player
;
;                                                                
; Ver 1.0                               Coded by Leandro Gentili /1999 
; Ver 1.1                              Modified by Michael Weston/2001  
; Ver 1.2                                                  April /2001 
;                      -Directory support added by Javier Saiz Sanchez
; Ver 1.3                                                  July / 2001
;*********************************************************************
	      org 0x1800
START_CD
		;---------------------------------------------------
		; This code was added because CD-ROM needs a reset
		; if the player should be reset by parallel port,
		; otherwise it stops functioning correctly.
		;---------------------------------------------------
		movlw		IDE_REG_CTRL		; raise srst
		movwf		PORTB
		movlw		h'06'
		movwf		PORTC
		movlw		DEMUX_IDE_WR
		movwf		PORTE
		bsf		PORTA,ENABLE
		nop
		bcf		PORTA,ENABLE
		movlw		h'02'			; lower srst
		movwf		PORTC
		bsf		PORTA,ENABLE
		nop
		bcf		PORTA,ENABLE
		;---------------------------------------------------

              call INI_ATAPI 	; Check to see if a CD-ROM attached                               
              
              btfss FLAG,ATAPIn
              goto S_ATAPI	; Yes

		  bsf		STATUS,RP0	; No, try hard drive code
		  movlw		b'11111111'	; C and D all inputs
		  movwf		TRISC		; C0-C7 inputs
		  movwf		TRISD		; D0-D7 inputs
		  bcf		STATUS,RP0
		  ; clear memory		; reflush all bank 0 memory
		  movlw		h'7f'
		  movwf		FSR
clrlp		  clrf		INDF
		  bsf		FSR,7
		  clrf		INDF
		  bcf		FSR,7
		  decf		FSR,1
		  movlw		h'1f'
		  xorwf           FSR,0
		  btfss		STATUS,Z
		  goto		clrlp

		  ; init scroll timer
		  movlw		d'1'
		  movwf		SCROLL_TIMER

		  bsf		CUR_STATUS,CS_AUX_AUDIO	; set so AUX1 gets selected first
		  bsf		CUR_STATUS,CS_MPEG_AUDIO ; currently in MPEG mode

		  movlw 0x08
		  movwf PCLATH
		  call SET_AUDIO_HD	; set bass, treble and volume levels for HD code

              movlw 0x10
              movwf PCLATH
              goto Start_HD
            
S_ATAPI                                                                     
              bsf MESSAJE,0       ; Muestro "Players Name"           
              movlw 0x08
              movwf PCLATH
              call MENSAJE_L1
		  call SET_AUDIO_CD
		  call VOLUMEN_DAC
		  call BASS_MAS
		  call TREBLE_MAS
              movlw 0x18
	      movwf PCLATH
              call ESPERA     
DENUEVO                                  
              movlw 0x00          ; Borro La Static Ram
              movwf BYTERAM 
              call FULL_BUFFERXX  

              call INI_CD                                                                        

              btfsc FLAG_CD,4
              goto NOCD

              btfss FLAG_CD,6     ; Hybrid espera eject command 
              goto SICD
              btfss FLAG_CD,5
              goto SICD
NOCD                              
              call RD_KEY         ; NO CD Eserar Eject Key  
              call STOP_PRESS
              btfsc FLAG_KEY1,STOP
              goto EJECT_RUTIN
              goto NOCD      
SICD                             
              call SET_MAX_SPEED  ; SI CD seteo La MAX SPEED
              movlw 0x08
              movwf PCLATH
              call NUMERO_SONG    ; Cuantas TRACKs Hay?          
              movlw 0x18
		  movwf PCLATH

              call ESPERA
              call ESPERA
              call ESPERA
              call ESPERA
                           
              movlw .8
              movwf TRANS_1
              movlw 0x40
              movwf TOPE    
              movlw .1
              movwf INDEX

		  bsf FLAG_STATE,BACKLIGHT
;**********************************************************
;        ThE BiG LoOp
;**********************************************************
LOOP
              bsf FLAG,MANTIENE
              clrf INDEX_LIST     ; Muestro Primer Track 
              movlw 0x08
              movwf PCLATH
              call NAME  
              movlw 0x18
		  movwf PCLATH
LOOPP                            
              call RD_KEY              
              call REW_PRESS
              btfss FLAG_KEY1,REW
              goto NONE
              decfsz INDEX
              goto PUTA
              movf TOTAL_SONG,w
              movwf INDEX            
              goto PUTA
NONE
              call FRD_PRESS
              btfss FLAG_KEY1,FRD
              goto NO_ROTO                  
              incf INDEX                                        
              movf INDEX,w
              subwf TOTAL_SONG,w
              btfsc STATUS,C
              goto PUTA
              movlw .1
              movwf INDEX                            
PUTA
              movlw 0x08
              movwf PCLATH
              call NAME        
              movlw 0x18
		  movwf PCLATH
;******************************************
;******************************************
NO_ROTO      
              call RD_KEY
              call MODE_PRESS 
              btfss FLAG_KEY1,MODE
              goto NO_PRESS
                            
              call CAL_BASE
                                 
              call RD_RAM
                    
              movf BYTERAM,w
              sublw 0x00
              btfss STATUS,Z
              goto DESELECT
SELECT         
              movlw .8
              movwf PCLATH 
              call CURSOR_L2
              movlw 0x18
		  movwf PCLATH

              incf INDEX_LIST
              movf INDEX_LIST,w 

              movwf BYTERAM                           
              call WR_RAM                                          

              goto NO_PRESS                     
;******************************************
;******************************************
DESELECT      
              movlw .8
              movwf PCLATH
              call NO_CURSOR_L2
              movlw 0x18
		  movwf PCLATH

              movf INDEX,w
              movwf TEMP3

              call RD_RAM
                    
              movf BYTERAM,w
              movwf TEMP4
              incf TEMP4
              
              clrf BYTERAM              
              call WR_RAM 
JIRA             
              movlw .1
              movwf INDEX                          
JIRO
              call CAL_BASE
                                 
              call RD_RAM
                    
              movf BYTERAM,w
              subwf TEMP4,w
              btfss STATUS,Z
              goto ORTO
              movf TEMP4,w
              movwf BYTERAM
              decf BYTERAM
              incf TEMP4

              call WR_RAM
              goto JIRA
ORTO
              movf INDEX,w
              subwf TOTAL_SONG,w
              btfsc STATUS,Z
              goto NO_PRE                            
              incf INDEX             
              goto JIRO
NO_PRE
              movf TEMP3,w
              movwf INDEX
              decf INDEX_LIST
;******************************************
;******************************************
NO_PRESS                                                                                                                         
              call ESPERA
              call RD_KEY
              call PLAY_PRESS
              btfsc FLAG_KEY1,PLAY
              goto PLAY_RUTIN

              call STOP_PRESS
              btfsc FLAG_KEY1,STOP
              goto EJECT_RUTIN                   

              call ESPERA1
              goto LOOPP
;***************************************************************************
;***************************************************************************
PLAY_RUTIN    
              movlw 0x44          ; CD-Mp3 apago AUX, CD-DA prendo AUX
              btfss FLAG_CD,5     ; Siempre con 5volts Dac seleccionado
              movlw 0x4C
              movwf BUFFERIIC+2
              movlw 0x08
              movwf PCLATH
              call INI_DAC
              movlw 0x18
		  movwf PCLATH

              bcf FLAG,MANTIENE
              call ESPERA                       
              movf INDEX_LIST,w
              sublw 0x00
              btfss STATUS,Z
              goto ADELA
              movf INDEX,w
              movwf TEMP3
              clrf INDEX  
OTRASS         
              incf INDEX_LIST     
              incf INDEX

              call CAL_BASE                       
              movf INDEX_LIST,w
              movwf BYTERAM                      
              call WR_RAM
             
              movf INDEX_LIST,w
              subwf TOTAL_SONG,w
              btfss STATUS,Z
              goto OTRASS              
              movf TEMP3,w
              movwf INDEX_LIST             
              movf TOTAL_SONG,w
              movwf TOTAL_LIST                     
              goto PLAYY
ADELA
              movf INDEX_LIST,w
              movwf TOTAL_LIST 
              movlw .1
              movwf INDEX_LIST                            
              goto PLAYY             
;***************************************************************************
;***************************************************************************
EJECT_RUTIN            
              movlw .2               
              movwf FLAG_CD
              call ST_UNIT
              call ESPERA              
              bsf MESSAJE1,1
              movlw .8
              movwf PCLATH 
              call MENSAJE_L1
              movlw 0x18
		  movwf PCLATH
              call ESPERA1              
              bsf MESSAJE1,2
              movlw .8
              movwf PCLATH
              call MENSAJE_L2
              movlw 0x18
		  movwf PCLATH
              call ESPERA1
MIRAR
              call RD_KEY
              call STOP_PRESS
              btfss FLAG_KEY1,STOP
              goto MIRAR        

              movlw .3
              movwf FLAG_CD
              call ST_UNIT
              call ESPERA
              bsf MESSAJE1,1
              movlw .8
              movwf PCLATH
              call MENSAJE_L2
              movlw 0x18
		  movwf PCLATH
              call ESPERA1
              goto DENUEVO              
;***************************************************************************
;***************************************************************************
PLAY_RUTIN1  
              btfss FLAG_STATE,REW
              goto HENNA
              incfsz CONT1
              goto HENNA
              incfsz CONT2
              goto HENNA
              bcf FLAG_STATE,REW
              goto PLAYY
HENNA
              btfss FLAG_STATE,FRD
              goto HENNA1
              incfsz CONT1
              goto HENNA1
              incfsz CONT2
              goto HENNA1
              bcf FLAG_STATE,FRD
              goto PLAYY
HENNA1
              btfss FLAG_STATE,MODE
              goto HENNA2
              btfsc FLAG_STATE,PAUSE
              call ESPERA11 
              incfsz CONT1
              goto HENNA2
              incfsz CONT2
              goto HENNA2
              movlw .8
              movwf PCLATH
              call TRACK_MENU  
              movlw 0x18
		  movwf PCLATH
              goto ESPECIAL
;************************************
;************************************
HENNA2
              call RD_KEY

              call PLAY_PRESS        
              btfsc FLAG_KEY1,PLAY
              goto RUT_PLAY
              call STOP_PRESS
              btfsc FLAG_KEY1,STOP
              goto RUT_STOP
              call MODE_PRESS
              btfss FLAG_KEY1,MODE
              goto HHHH
              incf CONTROL
              bsf FLAG_STATE,MODE
              movlw 0x08
              movwf PCLATH
              call MOSTRAR_CONTROL
              movlw 0x18
		  movwf PCLATH
              goto ESPECIAL
HHHH
              btfss FLAG_STATE,MODE
              goto NORMAL     
              movlw .8
              movwf PCLATH
              call CONTROLS
              movlw 0x18
		  movwf PCLATH
              goto ESPECIAL
NORMAL                  
              call REW_PRESS
              btfsc FLAG_KEY1,REW
              goto RUT_REW
              call FRD_PRESS
              btfsc FLAG_KEY1,FRD
              goto RUT_FWD    
ESPECIAL                  
              btfsc FLAG_STATE,PAUSE
              goto PLAY_RUTIN1
              btfsc FLAG_STATE,FRD
              goto PLAY_RUTIN1
              btfsc FLAG_STATE,REW
              goto PLAY_RUTIN1

              btfss FLAG_CD,5
              goto AUDII
              goto DEMAND
AUDII                                   
              call READ_SUB

              movf TEMP1,w
              sublw 0x13
              btfss STATUS,Z
              goto PLAY_RUTIN1

              goto RUT_FWD                               
;***********************************************************************
;***********************************************************************                                
RUT_PLAY                     
              btfsc FLAG_STATE,PAUSE
              goto UNPAUSE
               
              btfss FLAG_CD,5
              goto MUSIC
              bsf FLAG_STATE,PAUSE
              goto PLAY_RUTIN1
MUSIC
              bsf FLAG_STATE,PAUSE             
              bcf FLAG_CD,3
              call PAUSE_RESUME                
              call ESPERA
              movlw 0x44
              movwf BUFFERIIC+2
              movlw 0x08
              movwf PCLATH
              call INI_DAC
              movlw 0x18
		  movwf PCLATH
              goto PLAY_RUTIN1
;*******************************************
;*******************************************
UNPAUSE
              btfss FLAG_CD,5
              goto MUSIC1
              bcf FLAG_STATE,PAUSE 
              goto PLAY_RUTIN1
MUSIC1
              movlw 0x4C
              movwf BUFFERIIC+2
              movlw 0x08
              movwf PCLATH
              call INI_DAC
              movlw 0x18
		  movwf PCLATH
              bcf FLAG_STATE,PAUSE     
              bsf FLAG_CD,3
              call PAUSE_RESUME             
              call ESPERA
              goto PLAY_RUTIN1
;***********************************************************************
;***********************************************************************
PLAYY                                                            
              clrf INDEX              
OTRAS               
              incfsz INDEX
              goto NOCERO             
              movlw .1
              movwf INDEX_LIST 
              goto OTRAS
NOCERO
              call CAL_BASE
          
              call RD_RAM

              movf BYTERAM,w
              subwf INDEX_LIST,w
              btfss STATUS,Z
              goto OTRAS                            
;;;
              movlw 0x08
              movwf PCLATH
              call NAME
              call NO_CURSOR_L2            
              movlw 0x18
		  movwf PCLATH
;;;                             
              btfsc FLAG_STATE,FRD
              goto PLAY_RUTIN1
              btfsc FLAG_STATE,REW
              goto PLAY_RUTIN1

              call CAL_BASE

              btfss FLAG_CD,5
              goto PLAY_DA 
;*******************************************
;*******************************************
PLAY_MP3                               
              bcf FLAG,FINALMP3
              bcf FLAG,FINALMP31
       
              movlw .4
              movwf COUNTER
              movlw LBA_1  
              movwf FSR
MN1
              incfsz ADR_RL
              goto JK1
              incf ADR_RH
JK1
              call RD_RAM
              movf BYTERAM,w
              movwf INDF

              incf FSR
              decfsz COUNTER              
              goto MN1

              movlw .4
              movwf COUNTER
              movlw BASEF  
              movwf FSR
MN2
              incfsz ADR_RL
              goto JK2
              incf ADR_RH
JK2
              call RD_RAM
              movf BYTERAM,w
              movwf INDF

              incf FSR
              decfsz COUNTER              
              goto MN2               

              movlw 0x40
              subwf BASEF+1
              btfsc STATUS,C
              goto SIGUE1
              movlw .1
              subwf BASEF+2
              btfss STATUS,C
              subwf BASEF+3
SIGUE1                           
              call ESPERA

              call READ10
              call RD_STATUS_A
              call ST2               
              call FULL_BUFFER

              call ESPERA
                            
              bsf FLAG,MARCA1
              bsf FLAG,MARCA2             
DEM_RUTIN     
              movlw 0xFF
              movwf ADR_RL
              movwf ADR_RH
              clrf ADR_WL
              clrf ADR_WH                                     
DEMAND       
              btfsc PORTA,DEM     ; Si DEM pin =1 MANDA un BYTE         
              goto GATA
          
              btfsc FLAG,MARCA2
              goto DEMAND

              bsf FLAG,MARCA2              

              btfss FLAG,MARCA1
              goto PLAY_RUTIN1
 
              bcf FLAG,MARCA1
                         
              movlw 0x40
              subwf BASEF+1
              btfsc STATUS,C
              goto SIGUE
              movlw .1
              subwf BASEF+2
              btfsc STATUS,C
              goto SIGUE
              subwf BASEF+3
              btfsc STATUS,C
              goto SIGUE

              bsf FLAG,FINALMP3
              movlw 0x40        
              addwf BASEF+1              
SIGUE
              movlw 0x08             
              addwf LBA_1
              btfsc STATUS,C
              incfsz LBA_2
              goto MOMO
              incfsz LBA_3
              goto MOMO
              incf LBA_4
MOMO                                                     
              call RD_STATUS       
              movf STATUS_R,W      
              andlw b'10001000'     
              btfsc STATUS,Z       
              goto PL                      
              call RD_DATA_R
              goto MOMO
PL
              call READ10             
              goto DEMAND                        
GATA
              bcf FLAG,MARCA2
     
              incfsz ADR_RL        
              goto PLACE
	      incf ADR_RH 
PLACE           
              call RD_RAM
              call STREAM

              btfss FLAG,FINALMP31
              goto JIJO
              movf BASEF+1,w
              subwf ADR_RH,w
              btfss STATUS,Z
              goto JIJO
              goto RUT_FWD 
JIJO            
              movlw 0x20
	      subwf ADR_RH,w
              btfss STATUS,C
              goto DEMAND         ; < 8k                               
;**********************
;**********************
              call RD_DATA_R      ; > 8k 
              movf DATA_RL,w
              movwf BYTERAM
	      
              call WR_RAM

              incfsz ADR_WL
              goto ETIQUE
              incf ADR_WH
ETIQUE         
              movf DATA_RH,w
              movwf BYTERAM
              
              call WR_RAM
;**********************
;**********************
              incfsz ADR_WL
              goto JAMER
              incf ADR_WH                           
JAMER      
              movlw 0x3F
              subwf ADR_RH,w
              btfss STATUS,Z
              goto DEMAND 

              movlw 0xFF
              subwf ADR_RL,w
              btfss STATUS,Z
              goto DEMAND 

              btfsc FLAG,FINALMP3
              goto FINALL
               
              bsf FLAG,MARCA1
              bsf FLAG,MARCA2
              goto DEM_RUTIN
FINALL
              bsf FLAG,FINALMP31
              goto DEM_RUTIN
;*******************************************
;*******************************************
PLAY_DA             
              incfsz ADR_RL
              goto KOLO
              incf ADR_RH
KOLO
              call RD_RAM
              movf BYTERAM,w
              movwf START_M
                 
              incfsz ADR_RL
              goto KOLO1
              incf ADR_RH
KOLO1
              call RD_RAM
              movf BYTERAM,w
              movwf START_S

              incfsz ADR_RL
              goto KOLO2
              incf ADR_RH
KOLO2
              call RD_RAM
              movf BYTERAM,w
              movwf START_F
       
              incf INDEX
              call CAL_BASE
              decf INDEX 

              incfsz ADR_RL
              goto KOLO3
              incf ADR_RH
KOLO3        
              call RD_RAM
              movf BYTERAM,w
              movwf END_M
                 
              incfsz ADR_RL
              goto KOLO4
              incf ADR_RH
KOLO4
              call RD_RAM
              movf BYTERAM,w
              movwf END_S

              incfsz ADR_RL
              goto KOLO5
              incf ADR_RH
KOLO5
              call RD_RAM
              movf BYTERAM,w
              movwf END_F               
                                        
              call PLAY_AUDIO_MSF
              call ESPERA
              goto PLAY_RUTIN1 
;***********************************************************************
;***********************************************************************
RUT_REW       
              clrf CONT1
              movlw .225
              movwf CONT2
ST_11                               
              call RD_STATUS       
              movf STATUS_R,W      
              andlw b'10001000'     
              btfsc STATUS,Z       
              goto PL1                      
              call RD_DATA_R
              goto ST_11
PL1
              btfss FLAG_STATE,REW
              goto NUEVVA
              
              decfsz INDEX_LIST
              goto PLAYY
              movf TOTAL_LIST,w
              movwf INDEX_LIST                  
              goto PLAYY                                               
NUEVVA
              bsf FLAG_STATE,REW
              goto PLAYY                 
;***********************************************************************
;***********************************************************************
RUT_FWD      
              clrf CONT1
              movlw .225
              movwf CONT2           
              incf INDEX_LIST                                                                  
ST_12                               
              call RD_STATUS       
              movf STATUS_R,W      
              andlw b'10001000'     
              btfsc STATUS,Z       
              goto PL2                      
              call RD_DATA_R
              goto ST_12     
PL2
              bsf FLAG_STATE,FRD
              goto PLAYY                
;***********************************************************************
;***********************************************************************
RUT_STOP      
              movf INDEX,w
              movwf TEMP3
              movlw .1
              movwf INDEX
              clrf BYTERAM
PONGO0
              call CAL_BASE
              call WR_RAM
              incfsz INDEX
              goto PONGO0                

              movf TEMP3,w
              movwf INDEX
              
              clrf CONTROL
              bcf FLAG_STATE,MODE

              btfss FLAG_CD,5
              goto MUSIC2
ST_13                              
              call RD_STATUS       
              movf STATUS_R,W      
              andlw b'10001000'     
              btfsc STATUS,Z       
              goto LOOP                      
              call RD_DATA_R
              goto ST_13     
MUSIC2        
              movlw 0x44
              movwf BUFFERIIC+2
              movlw 0x08
              movwf PCLATH
              call INI_DAC
              movlw 0x18
		  movwf PCLATH
              bcf FLAG_CD,0
              bcf FLAG_CD,1        
              call ST_UNIT
              call ESPERA             
              goto LOOP              
;**********************************************************
;        DeLaYs
;**********************************************************                          
ESPERA11   
              btfss FLAG_CD,5
              goto DAD                      
              movlw .255
              movwf ACC1
              movlw .40
              movwf ACC2
              goto L1
DAD
              movlw .200
              movwf ACC1
              movlw .4
              movwf ACC2
              goto L1
ESPERA    
              movlw .255
              movwf ACC1
              movwf ACC2
              goto L1
ESPERA1   
              movlw .40        
              movwf ACC2
              movlw .1
              movwf ACC2
L1                      
              nop                 ; Aprox. 1 MicroSec.
              nop
              decfsz ACC1
              goto L1
              decfsz ACC2
              goto L1
              return

RD_STATUS         
	      movlw D_STATUS      ; Status 
              call RUTR 
              movwf STATUS_R
              return
;*************************
;*************************
RD_STATUS_A     
              movlw D_STATUS_A    ; Alternate Status 
              call RUTR 
              movwf STATUS_A
              return
;*************************
;*************************
RD_SC
              movlw D_SECTOR_C    ; Sector Count
              call RUTR
              movwf SECTOR_C
              return
;*************************
;*************************
RD_SN
	      movlw D_SECTOR_N    ; Sector Number 
              call RUTR                
       	      movwf SECTOR_N 
              return
;*************************
;*************************
RD_CL
              movlw D_CILYNDER_L  ; Cylinder Low
              call RUTR
              movwf CILYNDER_L
              return
;***************************
;***************************
RD_CH
              movlw D_CILYNDER_H  ; Cylinder High   
              call RUTR
              movwf CILYNDER_H   	
              return
;*************************
;*************************
RD_ERRORR
              movlw D_ERRORR      ; Error
              call RUTR
              movwf ERRORR
              return
;*************************
;*************************
RD_DATA_R                         ; Data
              bsf STATUS,RP0      ; PortC, PortD IN 
 	      movlw 0xFF              
              movwf TRISD         
	      movwf TRISC
	      bcf STATUS,RP0        

              movlw D_DATA_R      ; Register ATA 
              movwf PORTB

              movlw READ_IDE       
              movwf PORTE
              bsf PORTA,HAB_DEC   ; RDn Low

              nop
              movf PORTC,w        ; Read DD0..DD7 IDE
              movwf DATA_RL       
              movf PORTD,w        ; Read DD8..DD15 IDE
              movwf DATA_RH
              bcf PORTA,HAB_DEC   ; RDn high

              return                                  
;*****************************************
;*****************************************
WR_COMMAND          
              movf COMMAND,w      ; Command       
              movwf TEMPW
              movlw D_COMMAND
              call RUTW
              return
;*****************************************
;*****************************************
WR_SC	                 
	      movf SECTOR_C,w     ; Sector Count
              movwf TEMPW
	      movlw D_SECTOR_C     
	      call RUTW
	      return
;*****************************************
;*****************************************
WR_SN
	      movf SECTOR_N,w     ; Sector number
	      movwf TEMPW
	      movlw D_SECTOR_N    
	      call RUTW
	      return
;*****************************************
;*****************************************
WR_CL
	      movf CILYNDER_L,w   ; Cylinder Low
              movwf TEMPW
	      movlw D_CILYNDER_L     
              call RUTW
              return
;*****************************************
;*****************************************
WR_CH
	      movf CILYNDER_H,w   ; Cylinder High
	      movwf TEMPW
      	      movlw D_CILYNDER_H     
	      call RUTW
              return
;*****************************************
;*****************************************
WR_DC
	      movf DEVICE_C,w     ; Device Control
              movwf TEMPW
	      movlw D_DEVICE_C
              call RUTW
              return
;*****************************************
;*****************************************
WR_DH
	      movf DEVICE_H,w     ; Device Head 
	      movwf TEMPW
              movlw D_DEVICE_H
	      call RUTW
              return
;*****************************************
;*****************************************
WR_FEATURES
              movf FEATURES,w     ; Features
	      movwf TEMPW
	      movlw D_FEATURES
	      call RUTW
              return
;*****************************************
;*****************************************
WR_DATA_R                         ; Data
              bsf STATUS,RP0      ; PortC, PortD OUT
              clrf TRISD              
	      clrf TRISC
	      bcf STATUS,RP0       

              movlw D_DATA_R	  ; TEMPWistro ATA
              movwf PORTB

              movf DATA_RL,w      ; Write DD0..DD7 IDE 
              movwf PORTC         
              movf DATA_RH,w      ; Write DD8..DD15 IDE
              movwf PORTD
      
              movlw WRITE_IDE     
              movwf PORTE
              bsf PORTA,HAB_DEC   ; WRn Low                  
              bcf PORTA,HAB_DEC   ; WRn High
 
              return
;*****************************************
;*****************************************
RUTR          
              movwf PORTB         ; TEMPWistro ATA 

              bsf STATUS,RP0      ; PortC IN 
              movlw 0xFF
              movwf TRISC
              movwf TRISD
              bcf STATUS,RP0
 
              movlw READ_IDE       
              movwf PORTE
              bsf PORTA,HAB_DEC   ; RDn Low

              nop
              movf PORTC,w        ; Read DD0..D7 IDE
              bcf PORTA,HAB_DEC   ; RDn High                     

	      return
;*****************************************
;*****************************************
RUTW
              movwf PORTB         ; TEMPWistro ATA

              bsf STATUS,RP0      ; PortC OUT
	      clrf TRISC        
              clrf TRISD
	      bcf STATUS,RP0       

              movf TEMPW,w        ; Write DD0..DD7 IDE 
              movwf PORTC
              
              movlw WRITE_IDE  
              movwf PORTE      
              bsf PORTA,HAB_DEC   ; WRn Low
              bcf PORTA,HAB_DEC   ; WRn High 
       
              return
;*****************************************
;*****************************************   
RD_RAM  	        
              bsf STATUS,RP0      ; PortC,OUT PortD IN
 	      movlw 0xFF         
	      movwf TRISD        
              clrf TRISC
	      bcf STATUS,RP0
       
              movf ADR_RL,w       ; PortC A0..A7 
              movwf PORTC        
              movf ADR_RH,w       ; PortB A8..A15
              movwf PORTB

              movlw READ_RAM      
	      movwf PORTE

              bsf PORTA,HAB_DEC   ; RDn Low                               
              nop 
	      movf PORTD,w        ; Read Byte from RAM 
              movwf BYTERAM      
              bcf PORTA,HAB_DEC   ; RDn High   

              return
;*****************************************
;*****************************************   
WR_RAM 
              bsf STATUS,RP0      ; PortC, PortD OUT       
	      clrf TRISD        
              clrf TRISC
	      bcf STATUS,RP0

              movf ADR_WL,w       ; PortC A0..A7  
              movwf PORTC
              movf ADR_WH,w       ; PortB A8..A15
              movwf PORTB   

              movf BYTERAM,w      ; Write Byte to RAM 
              movwf PORTD         

              movlw WRITE_RAM
              movwf PORTE     
              bsf PORTA,HAB_DEC   ; WRn Low         
              bcf PORTA,HAB_DEC   ; WRn High
               
	      return
;**************************************************************************
;**************************************************************************
ST1                               ; Wait: 
              call RD_STATUS      ; Bsy =0 
              movf STATUS_R,W     ; Drq =0
              andlw b'10001000'     
              btfsc STATUS,Z
              return
              btfss STATUS_R,ERR
              goto ST1
              return
;**************************************************************************
;**************************************************************************
ST2                               ; Wait: 
              call RD_STATUS      ; Bsy =0 
              movf STATUS_R,W     ; Drq =1
              andlw b'10001000'     
              sublw b'00001000'
              btfsc STATUS,Z
              return
              btfss STATUS_R,ERR
              goto ST2               
              return                       
;**************************************************************************
;**************************************************************************
RD_BLOCK 
              call RD_ERRORR
              call RD_SC
              call RD_SN
              call RD_CL
              call RD_CH
              return
;**************************************************************************
;**************************************************************************
WR_BLOCK                
              call WR_FEATURES
              call WR_SC
              call WR_SN
              call WR_CL 
              call WR_CH
              call WR_COMMAND
              return
;**************************************************************************
;**************************************************************************
WR_PKT                            ; PACKET PARAMETERS 
              movf BP0,w
              movwf DATA_RL
              movf BP1,w
              movwf DATA_RH
              call WR_DATA_R
              movf BP2,w
              movwf DATA_RL
              movf BP3,w
              movwf DATA_RH
              call WR_DATA_R         
              movf BP4,w
              movwf DATA_RL
              movf BP5,w
              movwf DATA_RH
              call WR_DATA_R
              movf BP6,w
              movwf DATA_RL
              movf BP7,w
              movwf DATA_RH
              call WR_DATA_R
              movf BP8,w
              movwf DATA_RL
              movf BP9,w
              movwf DATA_RH
              call WR_DATA_R
              movf BP10,w
              movwf DATA_RL
              movf BP11,w
              movwf DATA_RH
              call WR_DATA_R
              return          
;**************************************************************************
;**************************************************************************
DEVICE_SELECT            
              call ST1
              clrf DEVICE_H
              call WR_DH
              call ST1
              return
;**************************************************************************
;**************************************************************************
INI_ATAPI     
              call DEVICE_SELECT                                                    
              movlw b'00000010'    
              movwf DEVICE_C
              call WR_DC         
              call ST1
                      
              call RD_BLOCK
              movf CILYNDER_L,w
              sublw 0x14
              btfss STATUS,Z
              goto N_ATAPI

              movf CILYNDER_H,w
              sublw 0xEB
              btfss STATUS,Z
              goto N_ATAPI

              bcf FLAG,ATAPIn
              return                                               
N_ATAPI
              bsf FLAG,ATAPIn
              return
;--------------------------------------------------------------------------
               ; ATA COMMANDs
DEVICE_RESET
              call DEVICE_SELECT
              clrf FEATURES
              clrf SECTOR_C
              clrf SECTOR_N
              clrf CILYNDER_L
              clrf CILYNDER_H
              clrf DEVICE_H
              movlw 0x08
              movwf COMMAND
              call WR_BLOCK
              return
             
WR_C_P                            ; ATAPI Command Packet
              call ST1 
              clrf FEATURES       ; Byte count limit 16k            
              clrf SECTOR_C         
              clrf SECTOR_N	  
              movlw 0xFF
              movwf CILYNDER_L
              movlw 0xFF
              movwf CILYNDER_H
              clrf DEVICE_H
              movlw 0xA0 
              movwf COMMAND                  
              call WR_BLOCK
              return
;---------------------------------------------------------------------------
               ; ATAPI COMMANDs                    
READ10         
              call WR_C_P
              call ST2
              movlw 0x28
              movwf BP0
              clrf BP1
              movf LBA_1,w
              movwf BP5
              movf LBA_2,w
              movwf BP4
              movf LBA_3,w
              movwf BP3
              movf LBA_4,w
              movwf BP2   
              clrf BP6
              movf TRANS_2,w
	      movwf BP7	 			
              movf TRANS_1,w      ; Read 8 blocks (16Kbytes)
              movwf BP8
              clrf BP9
              clrf BP10
              clrf BP11
              call WR_PKT
              return

PLAY_AUDIO_MSF                
              call WR_C_P
              call ST2
              movlw 0x47
              movwf BP0
              clrf BP1
	      clrf BP2
              movf START_M,w
              movwf BP3
              movf START_S,w
              movwf BP4
              movf START_F,w
              movwf BP5
              movf END_M,w
              movwf BP6
              movf END_S,w
              movwf BP7
              movf END_F,w
              movwf BP8
              clrf BP9
              clrf BP10
              clrf BP11
              call WR_PKT
              call RD_STATUS_A
              call ST1
              return

READ_TOC
              call WR_C_P
              call ST2
              movlw 0x43
              movwf BP0
	      movlw 0x02  
              movwf BP1
	      clrf BP2
              clrf BP3
              clrf BP4
              clrf BP5
              clrf BP6
              movlw 0x10
              movwf BP7
              clrf BP8
              clrf BP9
              clrf BP10
              clrf BP11
              call WR_PKT               
              call RD_STATUS_A
              call ST2 
              return

REQUEST_SENSE
              call WR_C_P
              call ST2
              movlw 0x03
              movwf BP0
              clrf BP1
	      clrf BP2
              clrf BP3
              movlw 0x12
              movwf BP4
              clrf BP5
              clrf BP6
              clrf BP7
              clrf BP8
              clrf BP9
              clrf BP10
              clrf BP11
              call WR_PKT               
              call RD_STATUS_A
              call ST2            
              btfsc STATUS_R,ERR
              return               
	                          ; Byte Returned
              call RD_DATA_R      ;0,1
              call RD_DATA_R      ;2,3 
              movf DATA_RL,w        
              andlw b'00001111'     
              movwf TEMP1         ; Sense Key
              call RD_DATA_R      ;4,5
              call RD_DATA_R      ;6,7
              call RD_DATA_R      ;8,9
              call RD_DATA_R      ;10,11
              call RD_DATA_R      ;12,13
              movf DATA_RL,w
              movwf TEMP2         ; ASC
              movf DATA_RH,w
              movwf TEMP3         ; ASCQ
              call RD_DATA_R      ;14,15 
              call RD_DATA_R      ;16,17
              return

ST_UNIT
              call WR_C_P
              call ST2
              movlw 0x1B
              movwf BP0
              clrf BP1
	      clrf BP2
              clrf BP3
              movf FLAG_CD,w
              movwf BP4
              clrf BP5
              clrf BP6
              clrf BP7
              clrf BP8
              clrf BP9
              clrf BP10
              clrf BP11
              call WR_PKT               
              call RD_STATUS_A
              call ST1 
              return

PAUSE_RESUME
              call WR_C_P
              call ST2
              movlw 0x4B
              movwf BP0
              clrf BP1
	      clrf BP2
              clrf BP3
              clrf BP4
              clrf BP5
              clrf BP6
              clrf BP7
              movlw 0x00          
              btfsc FLAG_CD,3
              movlw 0x01         
              movwf BP8               
              clrf BP9
              clrf BP10
              clrf BP11
              call WR_PKT               
              call RD_STATUS_A
              call ST1 
              return

READ_SUB
              call WR_C_P
              call ST2
              movlw 0x42
              movwf BP0
              movlw 0x02
              movwf BP1
              movlw 0x40
              movwf BP2
              movlw 0x01
              movwf BP3
              clrf BP4
              clrf BP5
              clrf BP6
              clrf BP7
              movlw .15
              movwf BP8
              clrf BP9
              clrf BP10
              clrf BP11
              call WR_PKT               
              call RD_STATUS_A
              call ST2 
	                          ; Byte Returned
              call RD_DATA_R      ;1
              movf DATA_RH,w                  
              movwf TEMP1
              call RD_DATA_R       
              call RD_DATA_R      
              call RD_DATA_R
              call RD_DATA_R
              call RD_DATA_R
              call RD_DATA_R
              call RD_DATA_R
              return

SET_MAX_SPEED 
              call WR_C_P
              call ST2
              movlw 0xBB
              movwf BP0
              clrf BP1
	      movlw 0x00          ;Set Max Speed x1 (150 KB/s)  
              movwf BP2                    
              movlw 0x96
              movwf BP3
              clrf BP4
              clrf BP5
              clrf BP6
              clrf BP7
              clrf BP8
              clrf BP9
              clrf BP10
              clrf BP11
              call WR_PKT               
              return

BCD     
              bcf     STATUS,C                ; clear the carry bit
  	      movlw   .8
	      movwf   COUNTER1
	      clrf    DECENA
	      clrf    MILENA
loop8         
              rlf     L_BYTE
	      rlf     DECENA
	      rlf     MILENA
;
	      decfsz  COUNTER1
              goto    adjDEC

              movlw .8
              movwf PCLATH
              movf DECENA,w
              movwf TEMP2                
              rrf DECENA
              rrf DECENA
              rrf DECENA
              rrf DECENA,w
              andlw b'00001111'              
              addlw M_NUM-BASE2
              call MORO
              movwf DIG_2
		
              movlw .8
              movwf PCLATH
              movf TEMP2,w
              andlw b'00001111'
              addlw M_NUM-BASE2             
              call MORO 
              movwf DIG_1
		

              movlw .8
              movwf PCLATH
              movf MILENA,w           
              andlw b'00001111'
              addlw M_NUM-BASE2
              call MORO
              movwf DIG_3
		  movlw 0x18
		  movwf PCLATH 

                                  ; Saco los 0s que estan adelante
              movf DIG_3,w
              sublw 0x30
              btfss STATUS,Z
              return

              movlw 0x20
              movwf DIG_3 

              movf DIG_2,w
              sublw 0x30
              btfss STATUS,Z
              return

              movlw 0x20
              movwf DIG_2
              return
;
adjDEC	
              movlw   DECENA
	      movwf   FSR
	      call    adjBCD
;
	      movlw   MILENA
	      movwf   FSR
	      call    adjBCD
;
	      goto    loop8
;
adjBCD  
              movlw   0x03
	      addwf   INDF,w
	      movwf   TEMP1
	      btfsc   TEMP1,3          ; test if result > 7
	      movwf   INDF
	      movlw   0x30
	      addwf   INDF,w
	      movwf   TEMP1
	      btfsc   TEMP1,7         ; test if result > 7
	      movwf   INDF            ; save as MSD
              return

SENSE
              call REQUEST_SENSE

              movlw 0x00
              subwf TEMP2,w
              btfsc STATUS,Z
              return 

              movlw 0x28
              subwf TEMP2,w
              btfsc STATUS,Z
              return

              movlw 0x29
              subwf TEMP2,w
              btfsc STATUS,Z
              return                                      

              movlw 0x3A
              subwf TEMP2,w
              bcf FLAG_CD,4
              btfss STATUS,Z
              return

              bsf FLAG_CD,4
              goto MOSTRA
              return
;************
INI_CD   
              clrf FLAG_CD
              clrf TOTAL_SONG

              call SENSE                 
              call ESPERA

              call SENSE                 
              call ESPERA
 
HASTA_NOERROR              
              call READ_TOC
              btfss STATUS_R,ERR
              goto DALE 
              call SENSE
              btfsc FLAG_CD,4
              return
              goto HASTA_NOERROR                        
;************
DALE
              call RD_DATA_R      ; decremento 2 datos del TOC 
              movf DATA_RH,w        
              movwf COUNTER
              decf COUNTER
              decf COUNTER                   

              call RD_DATA_R      ;  2 datos que no sirven
              movlw 0x00
              movwf ADR_WL
              movlw 0x40
              movwf ADR_WH
              movlw .1
              movwf COUNTER2
DIFICIL              
              incfsz ADR_WL
              goto KA0
              incf ADR_WH 
;************
KA0                               ; Me Fijo si es ROM o DA 
              call RD_DATA_R
              movf DATA_RH,w
              andlw b'00000100'
              btfss STATUS,Z
              goto CDROM
              bsf MESSAJE,2
              bsf FLAG_CD,6
              goto VENDA
CDROM
              bsf MESSAJE,3
              bsf FLAG_CD,5
VENDA                  
              call RD_DATA_R
;************         
              call RD_DATA_R      ; Pongo MSF en la RAM 
              movf DATA_RH,w
              movwf BYTERAM
              call WR_RAM
         
              call RD_DATA_R       
              incfsz ADR_WL
              goto KA1
              incf ADR_WH 
KA1
              movf DATA_RL,w
              movwf BYTERAM
              call WR_RAM
   
              incfsz ADR_WL
              goto KA2
              incf ADR_WH 
KA2
              movf DATA_RH,w
              movwf BYTERAM
              call WR_RAM
;************   
              movlw .16
              movwf COUNTER1            ; Pongo 16 espacios 
              movlw 0x20
              movwf BYTERAM
DALE2B
              incfsz ADR_WL
              goto KA6B
              incf ADR_WH
KA6B
              call WR_RAM
              decfsz COUNTER1
              goto DALE2B
;************
              incfsz ADR_WL
              goto KA3
              incf ADR_WH 
KA3                      
              movlw M_TRACK-BASE2      ; Pongo "TRACK" en RAM
              movwf COUNTER1
MAMO
              movlw .8
              movwf PCLATH
              movf COUNTER1,w
              call MORO

              movwf BYTERAM
		  movlw 0x18
		  movwf PCLATH             
              call WR_RAM        

              incfsz ADR_WL
              goto KA4
              incf ADR_WH        
KA4              
              incf COUNTER1
              movlw M_NUM-BASE2
              subwf COUNTER1,w
              btfss STATUS,Z
              goto MAMO         
;************
              movlw 0x20
              movwf BYTERAM
              call WR_RAM

              incfsz ADR_WL
              goto KA77
              incf ADR_WH        
KA77      
              movf COUNTER2,w          ; Pongo el NUMERO del Track (XX)  
              movwf L_BYTE
              call BCD

              movf DIG_2,w
              movwf BYTERAM

              call WR_RAM

              incfsz ADR_WL
              goto KA5
              incf ADR_WH        
KA5
              movf DIG_1,w
              movwf BYTERAM 
              call WR_RAM
;************
              movlw .8
              movwf COUNTER1      ; Pongo 8 espacios 
              movlw 0x20
              movwf BYTERAM
DALE2
              incfsz ADR_WL
              goto KA6
              incf ADR_WH
KA6
              call WR_RAM
              decfsz COUNTER1
              goto DALE2                                     
;************          
              movlw .29           ; Dejo la Ram apuntando a la Proxima Cancion  
              addwf ADR_WL
              btfsc STATUS,C
              incf ADR_WH      
              incf COUNTER2
;************
              incf TOTAL_SONG

              movlw .8            ; Delecremento en 8 el contador del TOC 
              subwf COUNTER        
              btfss STATUS,Z
              goto DIFICIL      

              decf TOTAL_SONG
              btfss FLAG_CD,6     ; es DA,ROM or Hybrid?
              goto DATA_CD
              btfss FLAG_CD,5
              goto MOSTRA

              clrf MESSAJE
              bsf MESSAJE,4       ; Hybrid 
              goto MOSTRA                                            
              
MOSTRA              
              movlw .8
              movwf PCLATH
              call MENSAJE_L1     ; DA
              movlw 0x18
		  movwf PCLATH

              ;call ESPERA
              return
;***********************************************************
;*********************************************************** 
DATA_CD                     
              clrf TOTAL_SONG 

              call MOSTRA
            
              movlw 0x00
              movwf BYTERAM 
              call FULL_BUFFERXX

              call TEST_JOULIET          
            
              call TABLA_INFO 

              return

;***********************************************************
;*********************************************************** 
TEST_JOULIET
              movlw 0x08
              movwf TOPE
              movlw 0x01
              movwf TRANS_1            
              clrf TRANS_2
              clrf LBA_4
              clrf LBA_3
              clrf LBA_2

              movlw .16
              movwf LBA_1
              call READ10
              call RD_STATUS_A
              call ST2
              call FULL_BUFFER
              call TEST

              btfsc FLAG,JOULIET
              return

              incf LBA_1
              call READ10
              call RD_STATUS_A
              call ST2
              call FULL_BUFFER
              call TEST
 
              btfsc FLAG,JOULIET
              return 
        
              incf LBA_1
              call READ10
              call RD_STATUS_A
              call ST2
              call FULL_BUFFER
              call TEST 

              btfsc FLAG,JOULIET
              return
              movlw .16
              movwf LBA_1
              call READ10
              call RD_STATUS_A
              call ST2

              call FULL_BUFFER
              return
TEST
              clrf ADR_RL
              clrf ADR_RH
              
GENTILI               
              call RD_RAM
              movlw .8
              movwf PCLATH

              movf ADR_RL,w              
              addlw M_ID-BASE2
              call MORO
		  movwf MIKE_TEMPW
              movlw 0x18
		  movwf PCLATH
		  movf MIKE_TEMPW,0
              subwf BYTERAM,w
              btfss STATUS,Z
              goto NO_JOULIET
              incf ADR_RL
              movlw 0x06
              subwf ADR_RL,w
              btfsc STATUS,Z
              goto SI_JOULIET
              goto  GENTILI

NO_JOULIET 
              bcf FLAG,JOULIET              
              return
SI_JOULIET
              bsf FLAG,JOULIET
              return          
;***********************************************************
;***********************************************************             
TABLA_INFO                       
              movlw .140		; En el bloque 0 esta el VD (Volumen Descriptor)
              movwf ADR_RL
              clrf ADR_RH              

              call RD_RAM           ; 141-144 direccion de la PT (Path Table)
              movf BYTERAM,w
              movwf LBA_1           ; Leo LBA del Path Table 
              call READ10             
              call RD_STATUS_A
              call ST2

              call FULL_BUFFER6	; Cargo PT en el bloque 6

		  movlw 0x00		; Inicializo ADR_W's 
              movwf ADR_WL
              movlw 0x40
              movwf ADR_WH		
		bsf STATUS,RP0
		  clrf PTADR_RL		; Inicializo PTADR_R's
	        movlw 0x30
		  movwf PTADR_RH		; Quedan apuntando al bloque 6 
		bcf STATUS,RP0
						
		
OTRODIR					; Empieza la Fiesta
		bsf STATUS,RP0
		  movf PTADR_RL,W		
		bcf STATUS,RP0
	        movwf ADR_RL
		bsf STATUS,RP0        
		  movf PTADR_RH,W
		bcf STATUS,RP0
	        movwf ADR_RH

              call RD_RAM		
		  movf BYTERAM,W
		  sublw 0x00
		  btfsc STATUS,Z 		; Si LEN_DI es 0 se acaba la Fiesta

	 	  RETURN
		  
		  movf BYTERAM,W		; Como LEN_DI es <>0 voy a avanzar los PTADR al siguiente RD
		bsf STATUS,RP0
		  addwf PTADR_RL		
              btfsc STATUS,C
		  incf PTADR_RH
		bcf STATUS,RP0

		  movlw .9			; Si LEN_DI es impar sumo 9
		  btfss BYTERAM,0
		  movlw .8		      ; Si LEN_DI es par sumo 8
		bsf STATUS,RP0
		  addwf PTADR_RL	
              btfsc STATUS,C
		  incf PTADR_RH		
		bcf STATUS,RP0
		  


              movlw 0x02		; voy a leer la direccion del DR
              addwf ADR_RL
		  

              call RD_RAM            ; 3-6 Location Directory Record (root)  
              movf BYTERAM,w
              movwf LBA_1
              incf ADR_RL
              call RD_RAM
              movf BYTERAM,w
              movwf LBA_2
              incf ADR_RL
              call RD_RAM           
              movf BYTERAM,w
              movwf LBA_3
              incf ADR_RL
              call RD_RAM
              movf BYTERAM,w
              movwf LBA_4

              call READ10
              call RD_STATUS_A
              call ST2

              call FULL_BUFFER0	; Cargo en el bloque 0 el DR
          
              movlw .11			; 11-18 Cantidad de Bytes del Root (DR)
	        movwf ADR_RL
              clrf ADR_RH                      

              call RD_RAM		;Leo la cantidad de bytes del DR
              movf BYTERAM,w
              movwf COUNTER2
              
              bcf STATUS,C
              rrf COUNTER2
              bcf STATUS,C
              rrf COUNTER2
              bcf STATUS,C
              rrf COUNTER2               

              movf COUNTER2,w     ; If counter = 0 lo pones en 1 
              sublw 0x00
              btfsc STATUS,Z
              incf COUNTER2

              clrf ADR_RL          
              clrf ADR_RH

                                  
              call RD_RAM        
              movf BYTERAM,w
              addwf ADR_RL

              call RD_RAM
              movf BYTERAM,w
              addwf ADR_RL          
;*****
QUIEROMAS
              movf ADR_RL,w
              movwf TEMP1
              movf ADR_RH,w
              movwf TEMP2
              movf ADR_WL,w 
              movwf TEMP4 
              movf ADR_WH,w 
              movwf TEMP5          
GRAN_LOOPY
		  call RD_RAM         ; Termino ? (=00)?
              movf BYTERAM,w
              movwf TEMP3
              sublw 0x00
              btfsc STATUS,Z
              goto FIN

;mi*****
		  MOVLW .25       ; Va a leer File Flags
		  ADDWF ADR_RL
		  BTFSC STATUS,C
		  INCF ADR_RH
		  CALL RD_RAM
		  BTFSC BYTERAM,1	; Si el bit 1 es '1' es un directorio
		  GOTO MITERMIN	; Es un Directorio, lo salta
;*      
		  MOVLW .7      
		  ADDWF ADR_RL
		  BTFSC STATUS,C
		  INCF ADR_RH
              CALL RD_RAM	; BYTERAM <-- Longitud del nombre del fichero
					
              btfss FLAG,JOULIET	; Si es Jouliet decrementa 4
              goto JN_JOU

              DECF BYTERAM
	        DECF BYTERAM
JN_JOU					; Si no es Jouliet decrementa 2
		  DECF BYTERAM
	        DECF BYTERAM
						
              MOVF BYTERAM,W 
		  ADDWF ADR_RL
		  BTFSC STATUS,C
		  INCF ADR_RH
		  CALL RD_RAM
 	
              MOVF BYTERAM,W	
              SUBLW 0x33		;'3' (*.??3 Posiblemente es un fichero MP3 
              BTFSS STATUS,Z
              GOTO MITERMIN    
	   
              MOVF TEMP1,w	; Salta al siguiente Registro de Directorio
              MOVWF ADR_RL
              MOVF TEMP2,w
              MOVWF ADR_RH
             


;mi*****		
              movlw .32           ; Pongo Todos (32)   en las posiciones del nombre (RAM)
              movwf COUNTER1
              movlw 0x20
              movwf BYTERAM                  

              movlw .9
              addwf ADR_WL
              btfsc STATUS,C
              incf ADR_WH
MAM              
              call WR_RAM              

              incfsz ADR_WL   
              goto BA8
              incf ADR_WH
BA8                                       
              decfsz COUNTER1            
              goto MAM
              
              movlw .40           ; Apunto Al Position LBA
              subwf ADR_WL
              btfss STATUS,C
              decf ADR_WH      

              movlw .2
              addwf ADR_RL
              btfsc STATUS,C
              incf ADR_RH                    
;********
              movlw 0x04
              movwf COUNTER         
TOTO
              call RD_RAM 
              call WR_RAM

              incfsz ADR_RL
              goto BA1
              incf ADR_RH
BA1
              incfsz ADR_WL
              goto BA2
              incf ADR_WH
BA2
              decfsz COUNTER          
              goto TOTO
;********         
              movlw .4
              addwf ADR_RL
              btfsc STATUS,C
              incf ADR_RH
           
              movlw 0x04
              movwf COUNTER
              movlw BASEF
              movwf FSR 
TOTO1
              call RD_RAM             
              movf BYTERAM,w
              movwf INDF          

              incfsz ADR_RL
              goto BA3
              incf ADR_RH
BA3
              incf FSR
              decfsz COUNTER          
              goto TOTO1           
;*********
              movf BASEF,w
              sublw 0x00
              btfss STATUS,Z
              goto UNOMAS
              movf BASEF+1,w
              andlw b'00000111'
              btfss STATUS,Z
              goto UNOMAS
              goto ROLA
UNOMAS
              movlw 0x08
              addwf BASEF+1
              btfss STATUS,C
              goto ROLA
              incfsz BASEF+2
              goto ROLA
              incf BASEF+3
ROLA                           
              clrf BASEF              
;********                                
              movlw 0x04
              movwf COUNTER
              movlw BASEF
              movwf FSR
TOTO2                        
              movf INDF,w
              movwf BYTERAM
              call WR_RAM

              incfsz ADR_WL
              goto BA4
              incf ADR_WH
BA4
              incf FSR
              decfsz COUNTER          
              goto TOTO2        
;*********
              movlw .18           ; Apunto Al largo del nombre
              addwf ADR_RL
              btfsc STATUS,C
              incf ADR_RH

              movlw .16
              movwf COUNTER        
OTTO
              btfss FLAG,JOULIET
              goto N_JOU1
                
              incfsz ADR_RL   
              goto BA5
              incf ADR_RH
BA5
              call RD_RAM
N_JOU1
              incfsz ADR_RL   
              goto BA6
              incf ADR_RH
BA6       
              call RD_RAM
              movf BYTERAM,w

              sublw 0x2D          ; Separador -   
              btfsc STATUS,Z
              goto TERMINB

              movf COUNTER,w
              sublw 0x00
              btfsc STATUS,Z
              goto OTTO   

              call WR_RAM           

              incfsz ADR_WL   
              goto BA7
              incf ADR_WH
BA7
              decf COUNTER
              goto OTTO             
;*********                      
TERMINB              
              movf COUNTER,w
              addwf ADR_WL
              btfsc STATUS,C
              incf ADR_WH

              movlw .16
              movwf COUNTER        
OTTOB
              btfss FLAG,JOULIET
              goto N_JOU1B
                
              incfsz ADR_RL   
              goto BA5B
              incf ADR_RH
BA5B
              call RD_RAM
N_JOU1B
              incfsz ADR_RL   
              goto BA6B
              incf ADR_RH
BA6B       
              call RD_RAM
              movf BYTERAM,w

              sublw 0x2E          ; Separador .   
              btfsc STATUS,Z
              goto TERMIN

              movf COUNTER,w
              sublw 0x00
              btfsc STATUS,Z
              goto OTTOB

              call WR_RAM           

              incfsz ADR_WL   
              goto BA7B
              incf ADR_WH
BA7B
              decf COUNTER
              goto OTTOB
;*********
TERMIN
              movlw .64
              addwf TEMP4
              btfsc STATUS,C
              incf TEMP5
              movf TEMP4,w
              movwf ADR_WL
              movf TEMP5,w
              movwf ADR_WH 

              incf TOTAL_SONG                  

MITERMIN      movf TEMP3,w
              addwf TEMP1
              btfsc STATUS,C
              incf TEMP2
              movf TEMP1,w
              movwf ADR_RL
              movf TEMP2,w
              movwf ADR_RH

              goto GRAN_LOOPY             
FIN           
              decfsz COUNTER2
              goto MAASS 
		  goto OTRODIR		; Paso al siguiente directorio
MAASS
             
              incfsz LBA_1
              goto LELA
              incfsz LBA_2
              goto LELA
              incfsz LBA_3
              goto LELA
              incf LBA_4
LELA
              call READ10
              call RD_STATUS_A
              call ST2

              call FULL_BUFFER0                           
   
              clrf ADR_RL		; Ha escrito en el bloque 0
              clrf ADR_RH      
	              
              call RD_RAM         ; Termino ? (=00)?
              movf BYTERAM,w
              movwf TEMP3 
              sublw 0x00
              btfss STATUS,Z
              goto QUIEROMAS
		  goto OTRODIR		; Paso al siguiente Directorio

STREAM
              clrf PORTC
		  btfsc FLAG_STATE,BACKLIGHT
		  bsf PORTC,5
              movlw IIS_MAS
              movwf PORTE
              bsf PORTA,HAB_DEC

	      bsf PORTC,SID      
              bsf PORTC,SIC     
              btfss BYTERAM,7  
              bcf PORTC,SID      
              bcf PORTC,SIC                    

              bsf PORTC,SID      
              bsf PORTC,SIC     
	      btfss BYTERAM,6   
              bcf PORTC,SID      
              bcf PORTC,SIC     
       
              bsf PORTC,SID     
	      bsf PORTC,SIC     
              btfss BYTERAM,5      
              bcf PORTC,SID      
              bcf PORTC,SIC     
        
              bsf PORTC,SID     
	      bsf PORTC,SIC     
              btfss BYTERAM,4   
              bcf PORTC,SID      
              bcf PORTC,SIC     
 
              bsf PORTC,SID     
	      bsf PORTC,SIC
              btfss BYTERAM,3   
              bcf PORTC,SID      
              bcf PORTC,SIC     

              bsf PORTC,SID      
	      bsf PORTC,SIC     
              btfss BYTERAM,2   
              bcf PORTC,SID     
              bcf PORTC,SIC     
        
              bsf PORTC,SID     
	      bsf PORTC,SIC    
              btfss BYTERAM,1   
              bcf PORTC,SID      
              bcf PORTC,SIC    
	
              bsf PORTC,SID    
	      bsf PORTC,SIC    
              btfss BYTERAM,0  
              bcf PORTC,SID     
              bcf PORTC,SIC     
       
              bcf PORTA,HAB_DEC
              return

RD_KEY
               clrf FLAG_KEY1
               clrf BYTERAM 
               movlw .1
               movwf COUNTER
LOOP22
               movf COUNTER,w
               movwf PORTB
               
               btfsc PORTA,KEY_IN
               iorwf BYTERAM
               clrf PORTB
               bcf STATUS,C
               rlf COUNTER
               btfss COUNTER,5
               goto LOOP22
               return
;***************************************************************************
;***************************************************************************
PLAY_PRESS                           
               btfss BYTERAM,PLAY
               goto NOAPRE1               
               goto CHE1

NOAPRE1        bcf FLAG_KEY,PLAY
               return
CHE1        
               btfsc FLAG_KEY,PLAY
               return

               bsf FLAG_KEY,PLAY
               bsf FLAG_KEY1,PLAY
               return
;***************************************************************************
;***************************************************************************
REW_PRESS                                         
               btfss BYTERAM,REW
               goto NOAPRE2               
               goto CHE2
NOAPRE2
               btfss FLAG,MANTIENE 
               goto PEPE
	       movlw .15
               movwf CONT1	
PEPE
               bcf FLAG_KEY,REW
               return
CHE2        
               btfss FLAG_KEY,REW
               goto GOMA 
               btfss FLAG,MANTIENE
               return
               decfsz CONT1
               return
               movlw .3
               movwf CONT1
GOMA
               bsf FLAG_KEY,REW
               bsf FLAG_KEY1,REW
               return
;***************************************************************************
;***************************************************************************
FRD_PRESS                           
               btfss BYTERAM,FRD
               goto NOAPRE3               
               goto CHE3
NOAPRE3
               btfss FLAG,MANTIENE 
               goto PEPE2
	       movlw .15
               movwf CONT2	
PEPE2
               bcf FLAG_KEY,FRD
               return
CHE3        
               btfss FLAG_KEY,FRD
               goto GOMA1
               btfss FLAG,MANTIENE
               return
               decfsz CONT2
               return
               movlw .3
               movwf CONT2              
GOMA1
               bsf FLAG_KEY,FRD
               bsf FLAG_KEY1,FRD
               return
;***************************************************************************
;***************************************************************************
STOP_PRESS                           
               btfss BYTERAM,STOP
               goto NOAPRE4               
               goto CHE4

NOAPRE4        bcf FLAG_KEY,STOP
               return
CHE4        
               btfsc FLAG_KEY,STOP
               return

               bsf FLAG_KEY,STOP
               bsf FLAG_KEY1,STOP
               return
;***************************************************************************
;***************************************************************************
MODE_PRESS                           
               btfss BYTERAM,MODE
               goto NOAPRE5               
               goto CHE5

NOAPRE5        bcf FLAG_KEY,MODE
               return
CHE5        
               btfsc FLAG_KEY,MODE
               return

               bsf FLAG_KEY,MODE
               bsf FLAG_KEY1,MODE
               return

;**********************************************************
;        Ram (External Static Ram) 
;**********************************************************
FULL_BUFFER 
		  clrf ADR_WL
              clrf ADR_WH 
FULL
              call RD_DATA_R       
              movf DATA_RL,w
              movwf BYTERAM
              call WR_RAM
  
              incfsz ADR_WL
              goto TROLE
              incf ADR_WH
TROLE         
              movf DATA_RH,w
              movwf BYTERAM
	        call WR_RAM

;**********************
;**********************
              incfsz ADR_WL
              goto FORE
              incf ADR_WH
FORE     
              movf TOPE,w
              subwf ADR_WH,w
              btfss STATUS,Z
              goto FULL

		  movf TEMP1,W
		  movwf ADR_WL

		  movf TEMP2,W
		  movwf ADR_WH

              return
;**********************************************************
;**********************************************************
FULL_BUFFER0 
		  movf ADR_WL,W
		  movwf TEMP1

		  movf ADR_WH,W
		  movwf TEMP2

              clrf ADR_WL
              clrf ADR_WH 
FULL0
              call RD_DATA_R       
              movf DATA_RL,w
              movwf BYTERAM
              call WR_RAM
  
              incfsz ADR_WL
              goto TROLE0
              incf ADR_WH
TROLE0         
              movf DATA_RH,w
              movwf BYTERAM
	        call WR_RAM

;**********************
;**********************
              incfsz ADR_WL
              goto FORE
              incf ADR_WH
FORE0     

		  movlw 0x08
              subwf ADR_WH,w
              btfss STATUS,Z
              goto FULL0

		  movf TEMP1,W
		  movwf ADR_WL

		  movf TEMP2,W
		  movwf ADR_WH

              return
;**********************************************************

;**********************************************************
FULL_BUFFER6
		  movf ADR_WL,W
		  movwf TEMP1

		  movf ADR_WH,W
		  movwf TEMP2

              clrf ADR_WL
		  movlw 0x30
		  movwf ADR_WH
             
FULL6
              call RD_DATA_R       
              movf DATA_RL,w
              movwf BYTERAM
	        call WR_RAM

              incfsz ADR_WL
              goto TROLE6
              incf ADR_WH
TROLE6         
              movf DATA_RH,w
              movwf BYTERAM
	        call WR_RAM

;**********************
;**********************
              incfsz ADR_WL
              goto FORE6
              incf ADR_WH
FORE6     
		  movlw 0x38
              subwf ADR_WH,w
              btfss STATUS,Z
              goto FULL6

		  movf TEMP1,W
		  movwf ADR_WL

		  movf TEMP2,W
		  movwf ADR_WH

              return
;**********************************************************

;********************************************************** 
FULL_BUFFERXX 
              clrf ADR_WL
              clrf ADR_WH 
              
FULL1
	      call WR_RAM

              incfsz ADR_WL
              goto TROLE1
              incf ADR_WH                   
;**********************
;**********************            
TROLE1
              movlw 0x80
              subwf ADR_WH,w
              btfss STATUS,Z
              goto FULL1
              movlw 0x00
              subwf ADR_WL,w
              btfss STATUS,Z
              goto FULL1 
              return
;**********************************************************
;**********************************************************
CAL_BASE       
              movf INDEX,w                  
              movwf TEMP1
              decf TEMP1
              clrf TEMP2
                 
              bcf STATUS,C
              rlf TEMP1
              rlf TEMP2
              bcf STATUS,C
              rlf TEMP1
              rlf TEMP2
              bcf STATUS,C
              rlf TEMP1
              rlf TEMP2
              bcf STATUS,C
              rlf TEMP1
              rlf TEMP2
              bcf STATUS,C
              rlf TEMP1
              rlf TEMP2
              bcf STATUS,C
              rlf TEMP1,w
              rlf TEMP2

              movwf ADR_RL
              movf TEMP2,w
              addlw 0x40
              movwf ADR_RH

              movf ADR_RL,w
              movwf ADR_WL
              movf ADR_RH,w
              movwf ADR_WH
              return
          
CAL_DEST_DA
              movlw .4
              addwf ADR_RL
              btfsc STATUS,C
              incf ADR_RH                                 
              return           

CAL_DEST_CDROM
              movlw .9
              addwf ADR_RL
              btfsc STATUS,C
              incf ADR_RH                                 
              return

